import { Component, OnInit } from '@angular/core';
import { User } from './models/user';
import { UserService } from './services/user.service';
import { GLOBAL } from './services/global';
import { Router } from '@angular/router';
import { IdAuthorized } from './models/idAuthorized';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  providers:[UserService]
})

export class AppComponent implements OnInit{
  public title = 'DEPORTY';
  public user: User;
  public user_register: User;
  public identity;
  public registro=false;
  public token;
  public errorMessage;
  public alertRegister;
  public idTelegram;
  public url;

  constructor(
    private _router: Router,
    private _userService:UserService
  ){
    this.user = new User('','','','','ROLE_USER','');
    this.user_register = new User('','','','','ROLE_USER','');
    this.url=GLOBAL.url
  }

  public ngOnInit(){
    this.errorMessage=null;
    this.alertRegister=null;
    this.identity = this._userService.getIdentity();
    this.token = this._userService.getToken();
    if(this._userService.getIdTelegram()!==null){
      this.idTelegram = this._userService.getIdTelegram();
    }else{
      this.idTelegram = "Sin insertar"
    }
    
  }


  public onSubmit(){
    
    this._userService.singup(this.user).subscribe(
      response=>{
        let identity = response.user;
        this.identity = identity;

        if(!this.identity._id){
          alert("El usuario no está correctamente identificado")
        }else{
          //Crear elemento en el localstorage para tener al usuario en sesión
          localStorage.setItem('identity',JSON.stringify(identity));

          //Conseguir el token para enviar a http
          this._userService.singup(this.user,'true').subscribe(
            response=>{
              let token = response.token;
              this.token = token;
      
              if(this.token.length<=0){
                alert("El token no se ha generado correctamente");
              }else{
                // Crear elemento en el localstorage para tener el token disponible
                localStorage.setItem('token',token);
                this._userService.getIdAuthorized(this.identity._id).subscribe(
                  response=>{
                    if(!response.idAuthorizedFind||!response.idAuthorizedFind[0]){
                      
                    }else{
                      this.idTelegram=response.idAuthorizedFind[0].idTelegram;
                      localStorage.setItem('idTelegram',this.idTelegram);
                      this.idTelegram=response.idAuthorizedFind[0].idTelegram;
                    }
                  },
                  error=>{
                   
                  }
                )
                this.user = new User('','','','','ROLE_USER','');
              }
            },
            error=>{
              var errorMessage = <any>error;
              if(errorMessage!=null){
                var body = JSON.parse(error._body);
                this.errorMessage=body.message;
              }
            }
          );
        }
      },
      error=>{
        var errorMessage = <any>error;
        if(errorMessage!=null){
          var body = JSON.parse(error._body);
          this.errorMessage=body.message;
          console.log(error);
        }
      }
    );
  }

  public onSubmitRegister(){
    if(this.user_register.email && (this.user_register.password!=null&&this.user_register.password!="") && this.checkEmail(this.user_register.email)){
      this._userService.register(this.user_register).subscribe(
        response=>{
          let user = response.user;
          this.user_register=user;
          if(!user._id){
            this.alertRegister='Error al registrarse';
          }else{
            this.alertRegister='El registro se ha realizado correctamente';
            this.user_register = new User('','','','','ROLE_USER','');
          }
        },
        error=>{
          var errorMessage = <any>error;
          if(errorMessage!=null){
            var body = JSON.parse(error._body);
            this.alertRegister=body.message;
          }
        }
      );
    }else{
      this.alertRegister='Error al registrarse, email no válido';
    }
}

  private checkEmail(email:string){
    var emailValid=/^(([^<>()[\]\.,;:\s@\"]+(\.[^<>()[\]\.,;:\s@\"]+)*)|(\".+\"))@(([^<>()[\]\.,;:\s@\"]+\.)+[^<>()[\]\.,;:\s@\"]{2,})$/i;
    if(emailValid.test(email)){
      return true;
    }else{
      return false;
    };
  }

  public logout(){
    localStorage.removeItem('identity');
    localStorage.removeItem('token');
    localStorage.removeItem('idTelegram');
    this._router.navigateByUrl('/');
    this.idTelegram=null;
    this.identity = null;
    this.token = null;
  }

  public changeViewToRegister(){
      this.registro=true
    
  }

  public changeViewToLogin(){
      this.registro=false
  }
}
