import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { HttpModule } from '@angular/http';
import { AgmCoreModule,AgmMap } from '@agm/core';

import { AppComponent } from './app.component';
import { UserEditComponent } from './components/user-edit.component';
import { routing, appRoutingProviders } from './app.routing';
import { HomeComponent } from './components/home.component';
import { SportListComponent } from './components/sport-list.component';
import { SportAddComponent } from './components/sport-add.component';
import { SportEditComponent } from './components/sport-edit.component';
import { SportDetailComponent } from './components/sport-detail.component';
import { TeamListComponent } from './components/team-list.component';
import { TeamAddComponent } from './components/team-add.component';
import { TeamEditComponent } from './components/team-edit.component';
import { TeamDetailComponent } from './components/team-detail.component';
import { GameListComponent } from './components/game-list.component';
import { GameAddComponent } from './components/game-add.component';
import { GameEditComponent } from './components/game-edit.component';
import { GameDetailComponent } from './components/game-detail.component';

@NgModule({
  declarations: [
    AppComponent,
    UserEditComponent,
    HomeComponent,
    SportListComponent,
    SportAddComponent,
    SportEditComponent,
    SportDetailComponent,
    TeamListComponent,
    TeamAddComponent,
    TeamEditComponent,
    TeamDetailComponent,
    GameListComponent,
    GameAddComponent,
    GameEditComponent,
    GameDetailComponent
  ],
  imports: [
    BrowserModule,
    FormsModule,
    HttpModule,
    routing,
    AgmCoreModule,
    AgmCoreModule.forRoot({
      apiKey: 'AIzaSyAcih4KVJGTJs_pgULUCpCXooTY4qNWR2A'
    },)
  ],
  providers: [appRoutingProviders],
  bootstrap: [AppComponent]
})
export class AppModule { }
