import { ModuleWithProviders } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

//Import user
import { UserEditComponent } from './components/user-edit.component';
import { HomeComponent } from './components/home.component';

//Import Sport
import { SportListComponent } from './components/sport-list.component';
import { SportAddComponent } from './components/sport-add.component';
import { SportEditComponent } from './components/sport-edit.component';
import { SportDetailComponent } from './components/sport-detail.component';


//Import Team
import { TeamListComponent } from './components/team-list.component';
import { TeamAddComponent } from './components/team-add.component';
import { TeamEditComponent } from './components/team-edit.component';
import { TeamDetailComponent } from './components/team-detail.component';

//Import Game
import { GameListComponent } from './components/game-list.component';
import { GameAddComponent } from './components/game-add.component';
import { GameEditComponent } from './components/game-edit.component';
import { GameDetailComponent } from './components/game-detail.component';



const appRoutes: Routes = [
    {path: '', component:HomeComponent},
    {path: 'mis-datos', component:UserEditComponent},
    {path: 'deportes/:page',component:SportListComponent},
    {path: 'crear-deporte',component:SportAddComponent},
    {path: 'editar-deporte/:id',component:SportEditComponent},
    {path: 'deporte/:id',component:SportDetailComponent},
    {path: 'crear-equipo',component:TeamAddComponent},
    {path: 'equipos/:page&',component:TeamListComponent},
    {path: 'editar-equipo/:id',component:TeamEditComponent},
    {path: 'equipo/:id',component:TeamDetailComponent},
    {path: 'partidos', component:GameListComponent},
    {path: 'crear-partido',component:GameAddComponent},
    {path: 'editar-partido/:id',component:GameEditComponent},
    {path: 'partido/:id', component:GameDetailComponent},
    {path: '**', component:HomeComponent}
];

export const appRoutingProviders : any[]=[];
export const routing: ModuleWithProviders = RouterModule.forRoot(appRoutes);