import { Component, OnInit } from '@angular/core';
import { Router, ActivatedRoute, Params } from '@angular/router';
import { UserService } from '../services/user.service';
import { GLOBAL } from '../services/global';
import { TeamService } from '../services/team.service';
import { Team } from '../models/team';
import { SportService } from '../services/sport.service';
import { Sport } from '../models/sport';

@Component({
    selector: 'team-detail',
    templateUrl: '../views/team-detail.html',
    providers: [UserService,TeamService,SportService]
})

export class TeamDetailComponent implements OnInit{
    public titulo:string;
    public team:Team;
    public identity;
    public token;
    public url:string;
    public alertMessage;
    public sports:Sport[]
    public filesToUpload: Array<File>;

    constructor(
        private _route:ActivatedRoute,
        private _router:Router,
        private _userService:UserService,
        private _teamService:TeamService,
        private _sportService:SportService
    ){
        this.team = new Team('','','','','','');
        this.titulo = 'Crear nuevo equipo';
        this.identity = this._userService.getIdentity();
        this.token = this._userService.getToken();
        this.url = GLOBAL.url;
    }

    ngOnInit(){
        this.getTeam();
    }

    getTeam(){
        this._route.params.forEach((params:Params)=>{
            let id = params['id'];
            this._teamService.getTeam(this.token,id).subscribe(
                response=>{
                    if(!response.team){
                        this._router.navigate(['/'])
                    }else{
                        this.team = response.team;
                        console.log(this.team);
                    }
                },
                error=>{
                    var errorMessage = <any>error;
                    if(errorMessage!=null){
                        var body = JSON.parse(error._body);
                        console.log(error);
                        // this.alertMessage=body.message;;
                    }
                }
            );
        });
    }
}
