import { Injectable } from '@angular/core';
import { Http, Response, Headers, RequestOptions } from '@angular/http';
import 'rxjs/add/operator/map';
import { Observable } from 'rxjs/Observable';
import { GLOBAL } from './global';
import { Game } from '../models/game';
@Injectable()
export class GameService{
    public url:string;

    constructor(private _http: Http){
        this.url = GLOBAL.url;
    }

    getGames(token,id){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'partido-usuario/'+id,options).map(res=>res.json());
    }

    getActiveGame(token,id){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'partido-activo/'+id,options).map(res=>res.json());
    }

    getGame(token,id){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'partido/'+id,options).map(res=>res.json());
    }

    addGame(token,game: Game){
        let params = JSON.stringify(game);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        return this._http.post(this.url+'partido',params,{headers:headers}).map(res=>res.json());
    }

    
    editGame(token,id:string,game: Game){
        let params = JSON.stringify(game);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        return this._http.put(this.url+'partido/'+id,params,{headers:headers}).map(res=>res.json());
    }

    deleteGame(token,id:string){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });
        let options = new RequestOptions({headers:headers});
        return this._http.delete(this.url+'partido/'+id,options).map(res=>res.json());
    }

}