import { Injectable } from '@angular/core';
import { Http, Response, Headers, RequestOptions } from '@angular/http';
import 'rxjs/add/operator/map';
import { Observable } from 'rxjs/Observable';
import { GLOBAL } from './global';
import { Game } from '../models/game';
import { Participation } from '../models/participation';

@Injectable()
export class ParticipationService{
    public url:string;

    constructor(private _http: Http){
        this.url = GLOBAL.url;
    }

    getParticipationsGame(token,id){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'participantes-partido/'+id,options).map(res=>res.json());
    }

    addParticipation(token,participation:Participation){
        let params = JSON.stringify(participation);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        return this._http.post(this.url+'participa',params,{headers:headers}).map(res=>res.json());
    }

    deleteParticipation(token,id:string){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });
        let options = new RequestOptions({headers:headers});
        return this._http.delete(this.url+'participa/'+id,options).map(res=>res.json());
    }
}