import { Injectable } from '@angular/core';
import { Http, Response, Headers, RequestOptions } from '@angular/http';
import 'rxjs/add/operator/map';
import { Observable } from 'rxjs/Observable';
import { GLOBAL } from './global';
import { Rule } from '../models/rule';

@Injectable()
export class RuleService{
    public url:string;

    constructor(private _http: Http){
        this.url = GLOBAL.url;
    }

    getRules(token,id:string){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'reglas/'+id,options).map(res=>res.json());
    }

    deleteRule(token,id:string){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });
        let options = new RequestOptions({headers:headers});
        return this._http.delete(this.url+'regla/'+id,options).map(res=>res.json());
    }

    addRule(token,rule:Rule){
        let params = JSON.stringify(rule);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        return this._http.post(this.url+'regla',params,{headers:headers}).map(res=>res.json());
    }

    editRule(token,id:string,rule: Rule){
        let params = JSON.stringify(rule);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        return this._http.put(this.url+'regla/'+id,params,{headers:headers}).map(res=>res.json());
    }
}