import { Injectable } from '@angular/core';
import { Http, Response, Headers, RequestOptions } from '@angular/http';
import 'rxjs/add/operator/map';
import { Observable } from 'rxjs/Observable';
import { GLOBAL } from './global';
import { Sport } from '../models/sport';

@Injectable()
export class SportService{
    public url:string;

    constructor(private _http: Http){
        this.url = GLOBAL.url;
    }

    getSports(token,page){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'deportes/'+page,options).map(res=>res.json());
    }

    getSport(token,id:string){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'deporte/'+id,options).map(res=>res.json());
    }

    getAllSports(token){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'todos-deportes',options).map(res=>res.json());
    }

    addSport(token,sport: Sport){
        let params = JSON.stringify(sport);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        return this._http.post(this.url+'deporte',params,{headers:headers}).map(res=>res.json());
    }

    editSport(token,id:string,sport: Sport){
        let params = JSON.stringify(sport);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        return this._http.put(this.url+'deporte/'+id,params,{headers:headers}).map(res=>res.json());
    }

    deleteSport(token,id:string){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.delete(this.url+'deporte/'+id,options).map(res=>res.json());
    }
    
}