import { Injectable } from '@angular/core';
import { Http, Response, Headers, RequestOptions } from '@angular/http';
import 'rxjs/add/operator/map';
import { Observable } from 'rxjs/Observable';
import { GLOBAL } from './global';
import { Team } from '../models/team';

@Injectable()
export class TeamService{
    public url:string;

    constructor(private _http: Http){
        this.url = GLOBAL.url;
    }

    getTeams(token,page){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'equipos/'+page+'&',options).map(res=>res.json());
    }

    addTeam(token,team: Team){
        let params = JSON.stringify(team);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        return this._http.post(this.url+'equipo',params,{headers:headers}).map(res=>res.json());
    }

    getTeam(token,id){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'equipo/'+id,options).map(res=>res.json());
    }

    editTeam(token,id:string,team:Team){
        let params = JSON.stringify(team);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        return this._http.put(this.url+'equipo/'+id,params,{headers:headers}).map(res=>res.json());
    }

    deleteTeam(token,id:string){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });

        let options = new RequestOptions({headers:headers});
        return this._http.delete(this.url+'equipo/'+id,options).map(res=>res.json());
    }

    getTeamsBySport(token,id){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':token
        });
        let options = new RequestOptions({headers:headers});
        return this._http.get(this.url+'equipos-deporte/'+id,options).map(res=>res.json());
    }
}