import { Injectable } from '@angular/core';
import { Http, Response, Headers } from '@angular/http';
import 'rxjs/add/operator/map';
import { Observable } from 'rxjs/Observable';
import { GLOBAL } from './global';

@Injectable()
export class UserService{
    public identity;
    public token;
    public url:string;
    public idTelegram:string;

    constructor(private _http: Http){
        this.url = GLOBAL.url;
    }
    public singup(user_to_login,gethash=null){
        if(gethash!=null){
            user_to_login.gethash=gethash;
        }
        let json = JSON.stringify(user_to_login);
        let params = json;
        let headers = new Headers({'Content-Type':'application/json'});
        return this._http.post(this.url+'login',params,{headers:headers}).map(res=>res.json());
    }

    public register(user_to_register){
        let params =  JSON.stringify(user_to_register);;
        let headers = new Headers({'Content-Type':'application/json'});
        return this._http.post(this.url+'register',params,{headers:headers}).map(res=>res.json());
    }

    public updateUser(user_to_update){
        let params =  JSON.stringify(user_to_update);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':this.getToken()
        });
        return this._http.put(this.url+'update-user/'+user_to_update._id,params,{headers:headers}).map(res=>res.json());
    }

    public getIdentity(){
        let identity = JSON.parse(localStorage.getItem('identity'));

        if(identity != "undefined"){
            this.identity = identity;
        }else{
            this.identity=null;
        }

        return this.identity;
    }

    
    public getToken(){
        let token =localStorage.getItem('token');
        if(token != "undefined"){
            this.token=token;
        }else{
            this.token = null;
        }
        return this.token;
    }

    public getIdTelegram(){
        let idTelegram =localStorage.getItem('idTelegram');
        if(idTelegram != "undefined"){
            this.idTelegram=idTelegram;
        }else{
            this.idTelegram = null;
        }
        return this.idTelegram;
    }

    public generarTokenTelegram(user,telegramdata){
        let params =  JSON.stringify(telegramdata);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':this.getToken()
        });
        return this._http.post(this.url+'generar-token-telegram/'+user._id,params,{headers:headers}).map(res=>res.json());
    }

    public confirmTokenTelegram(user,telegramdata){
        let params =  JSON.stringify(telegramdata);
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':this.getToken()
        });
        return this._http.post(this.url+'confirmar-token-telegram/'+user._id,params,{headers:headers}).map(res=>res.json());
    }

    public getIdAuthorized(userId:String){
        let headers = new Headers({
            'Content-Type':'application/json',
            'Authorization':this.getToken()
        });
        return this._http.get(this.url+'id-telegram-datos-usuario/'+userId,{headers:headers}).map(res=>res.json());
    }
}